part of mvu_flutter;

/// Generic [Cmd] type
///
/// Value is not used anywhere, hence the dynamic type
typedef Cmd = dynamic Function(Dispatch dispatch);

/// Initial [Program]'s [View] type
///
/// Must be a function for lazy initialization
typedef InitialView<ModelType extends Model, MsgType extends Msg<ModelType>>
    = View<ModelType, MsgType> Function();

/// [dispatch]/[dispatchGlobal] function type
typedef Dispatch<ModelType extends Model> = Future<void> Function(
    Msg<ModelType> message);

/// [Subscriptions] function type
///
/// Subscriptions' type is dynamic because value is not used – subscriptions
/// are stored only for cancellation purposes
typedef Subscriptions<ModelType extends Model> = List<StreamSubscription>
    Function(Dispatch<ModelType> dispatch);
